<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="设备ID" prop="deviceId">
        <el-input v-model="formData.deviceId" placeholder="请输入设备ID" />
      </el-form-item>
      <el-form-item label="使用登记证号" prop="registrationNumber">
        <el-input v-model="formData.registrationNumber" placeholder="请输入使用登记证号" />
      </el-form-item>
      <el-form-item label="特种设备类别" prop="specialCategory">
        <el-input v-model="formData.specialCategory" placeholder="请输入特种设备类别" />
      </el-form-item>
      <el-form-item label="生产厂家" prop="manufacturer">
        <el-input v-model="formData.manufacturer" placeholder="请输入生产厂家" />
      </el-form-item>
      <el-form-item label="上次检验日期" prop="lastInspectionDate">
        <el-date-picker
          v-model="formData.lastInspectionDate"
          type="date"
          value-format="x"
          placeholder="选择上次检验日期"
        />
      </el-form-item>
      <el-form-item label="下次检验日期" prop="nextInspectionDate">
        <el-date-picker
          v-model="formData.nextInspectionDate"
          type="date"
          value-format="x"
          placeholder="选择下次检验日期"
        />
      </el-form-item>
      <el-form-item label="检验周期" prop="inspectionCycle">
        <el-input v-model="formData.inspectionCycle" placeholder="请输入检验周期" />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { SpecialApi, Special } from '@/api/device/special'

/** 特种设备信息 表单 */
defineOptions({ name: 'SpecialForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deviceId: undefined,
  registrationNumber: undefined,
  specialCategory: undefined,
  manufacturer: undefined,
  lastInspectionDate: undefined,
  nextInspectionDate: undefined,
  inspectionCycle: undefined,
  remark: undefined,
})
const formRules = reactive({
  deviceId: [{ required: true, message: '设备ID不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await SpecialApi.getSpecial(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as Special
    if (formType.value === 'create') {
      await SpecialApi.createSpecial(data)
      message.success(t('common.createSuccess'))
    } else {
      await SpecialApi.updateSpecial(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deviceId: undefined,
    registrationNumber: undefined,
    specialCategory: undefined,
    manufacturer: undefined,
    lastInspectionDate: undefined,
    nextInspectionDate: undefined,
    inspectionCycle: undefined,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>